
package net.mcreator.greengle.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.greengle.init.GreengleModItems;
import net.mcreator.greengle.init.GreengleModFluids;
import net.mcreator.greengle.init.GreengleModFluidTypes;
import net.mcreator.greengle.init.GreengleModBlocks;

public abstract class SlimeyWaterFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> GreengleModFluidTypes.SLIMEY_WATER_TYPE.get(), () -> GreengleModFluids.SLIMEY_WATER.get(), () -> GreengleModFluids.FLOWING_SLIMEY_WATER.get())
			.explosionResistance(100f).bucket(() -> GreengleModItems.SLIMEY_WATER_BUCKET.get()).block(() -> (LiquidBlock) GreengleModBlocks.SLIMEY_WATER.get());

	private SlimeyWaterFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.FALLING_WATER;
	}

	public static class Source extends SlimeyWaterFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends SlimeyWaterFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
